Index: branches/encoders/code/projects/libdragonfly/serial.c
===================================================================
--- branches/encoders/code/projects/libdragonfly/serial.c	(revision 1344)
+++ branches/encoders/code/projects/libdragonfly/serial.c	(revision 1345)
@@ -1,10 +1,38 @@
-/*
-	serial.c - Functions for using the RS232 serial port
-	
-	authors: Robotics Club, Colony Project, pkv
-	much code taken from FWR's library, author: Tom Lauwers
-*/
+/**
+ * Copyright (c) 2007 Colony Project
+ * 
+ * Permission is hereby granted, free of charge, to any person
+ * obtaining a copy of this software and associated documentation
+ * files (the "Software"), to deal in the Software without
+ * restriction, including without limitation the rights to use,
+ * copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following
+ * conditions:
+ * 
+ * The above copyright notice and this permission notice shall be
+ * included in all copies or substantial portions of the Software.
+ * 
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
+ * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
+ * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
+ * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
+ * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
+ * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
+ * OTHER DEALINGS IN THE SOFTWARE.
+ **/
 
+
+/**
+ * @file serial.c
+ * @brief Serial Input and Output
+ *
+ * Implementation of functions for serial input and output.
+ *
+ * @author Colony Project, CMU Robotics Club
+ **/
+
 #include <avr/io.h>
 #include <stdio.h>
 #include "serial.h"
@@ -21,29 +49,29 @@
   //Set baud rate
   // - 115200 (both wired and wireless) is UBRR=8, U2X=1
   // - 9600 is U2X =1, UBRR = 107.
-	#if (USB_BAUD == 115200)
-    UBRR0H = 0x00;
-    UBRR0L = 8;
-    UCSR0A |= _BV(U2X0);
-  #elif (USB_BAUD == 9600)
-    UBRR0H = 0x00;
-    UBRR0L = 103;
-    UCSR0A |= _BV(U2X0);
-  #else //Baud rate is defined in the header file, we should not get here
-    return;
-  #endif
+#if (USB_BAUD == 115200)
+  UBRR0H = 0x00;
+  UBRR0L = 8;
+  UCSR0A |= _BV(U2X0);
+#elif (USB_BAUD == 9600)
+  UBRR0H = 0x00;
+  UBRR0L = 103;
+  UCSR0A |= _BV(U2X0);
+#else //Baud rate is defined in the header file, we should not get here
+  return;
+#endif
 
   /*Enable receiver and transmitter */
-	UCSR0B |= (1<<RXEN0)|(1<<TXEN0);
+  UCSR0B |= (1<<RXEN0)|(1<<TXEN0);
 	
-	/* Set frame format: 8data, 1stop bit, asynchronous normal mode */
-	UCSR0C |= (1<<UCSZ00) | (1<<UCSZ01);
+  /* Set frame format: 8data, 1stop bit, asynchronous normal mode */
+  UCSR0C |= (1<<UCSZ00) | (1<<UCSZ01);
   
   // if we have enabled the stdio stuff, then we init it here
-  #ifdef USE_STDIO
-    /* Open the stdio stream corresponding to this port */
-    usb_fd = fdevopen(usb_putc, usb_getc);
-  #endif
+#ifdef USE_STDIO
+  /* Open the stdio stream corresponding to this port */
+  usb_fd = fdevopen(usb_putc, usb_getc);
+#endif
 }
 
 /**
@@ -55,29 +83,29 @@
   //Set baud rate
   // - 115200 (both wired and wireless) is UBRR=8, U2X=1
   // - 9600 is U2X =1, UBRR = 107.
-	#if (XBEE_BAUD == 115200)
-    UBRR1H = 0x00;
-    UBRR1L = 8;
-    UCSR1A |= _BV(U2X1);
-  #elif (XBEE_BAUD == 9600)
-    UBRR1H = 0x00;
-    UBRR1L = 103;
-    UCSR1A |= _BV(U2X1);
-  #else //Baud rate is defined in the header file, we should not get here
-    return;
-  #endif
+#if (XBEE_BAUD == 115200)
+  UBRR1H = 0x00;
+  UBRR1L = 8;
+  UCSR1A |= _BV(U2X1);
+#elif (XBEE_BAUD == 9600)
+  UBRR1H = 0x00;
+  UBRR1L = 103;
+  UCSR1A |= _BV(U2X1);
+#else //Baud rate is defined in the header file, we should not get here
+  return;
+#endif
 
-	//Enable receiver and transmitter
-	UCSR1B |= (1<<RXEN1)|(1<<TXEN1);
+  //Enable receiver and transmitter
+  UCSR1B |= (1<<RXEN1)|(1<<TXEN1);
 	
-	// Set frame format: 8data, 1stop bit, asynchronous normal mode
-	UCSR1C |= (1<<UCSZ10) | (1<<UCSZ11);
+  // Set frame format: 8data, 1stop bit, asynchronous normal mode
+  UCSR1C |= (1<<UCSZ10) | (1<<UCSZ11);
   
   // if we have enabled the stdio stuff, then we init it here
-  #ifdef USE_STDIO
-    /* Open the stdio stream corresponding to this port */
-    xbee_fd = fdevopen(xbee_putc, xbee_getc);
-  #endif
+#ifdef USE_STDIO
+  /* Open the stdio stream corresponding to this port */
+  xbee_fd = fdevopen(xbee_putc, xbee_getc);
+#endif
 }
 
 /**
@@ -86,8 +114,7 @@
  * @param c the character to send
  * @return 0 for success, nonzero for failure
  **/
-int usb_putc(char c) 
-{
+int usb_putc(char c) {
   // Wait until buffer is clear for sending
   loop_until_bit_is_set(UCSR0A, UDRE0);
 	
@@ -102,8 +129,7 @@
  * @param c the character to send
  * @return 0 for success, nonzero for failure
  **/
-int xbee_putc(char c) 
-{
+int xbee_putc(char c) {
   // Wait until buffer is clear for sending
   loop_until_bit_is_set(UCSR1A, UDRE1);
 	
@@ -118,18 +144,32 @@
  * @param s the string to send
  * @return 0 for success, nonzero for failure
  **/
-int usb_puts(char *s)
-{
-	char *t = s;
-	while (*t != 0)
-	{
-		usb_putc(*t);
-		t++;
-	}
+int usb_puts(char *s) {
+  char *t = s;
+  while (*t != 0) {
+    usb_putc(*t);
+    t++;
+  }
   return 0;
 }
 
 /**
+ * Sends a sequence of characters from program space over USB.
+ *
+ * @param s the string to send
+ **/
+void usb_puts_P (PGM_P s) {
+    char buf;
+	
+    while (memcpy_P (&buf, s, sizeof (char)), buf!=0) {
+        usb_putc (buf);
+        s++;
+    }
+}
+
+
+
+/**
  * Returns the first character in the buffer received from USB.
  * This function blocks execution until a character has been received.
  * xbee_init must be called before this function may be used.
@@ -138,13 +178,12 @@
  *
  * @see usb_init, usb_getc_nb
  **/
-int usb_getc(void)
-{
+int usb_getc(void) {
   // Wait for the receive buffer to be filled
   loop_until_bit_is_set(UCSR0A, RXC0);
 	
-	// Read the receive buffer
-	return UDR0;
+  // Read the receive buffer
+  return UDR0;
 }
 
 /**
@@ -157,13 +196,12 @@
  * 
  * @see xbee_init, xbee_getc_nb
  **/
-int xbee_getc(void)
-{
-	// Wait for the receive buffer to be filled
-    loop_until_bit_is_set(UCSR1A, RXC1);
+int xbee_getc(void) {
+  // Wait for the receive buffer to be filled
+  loop_until_bit_is_set(UCSR1A, RXC1);
 	
-	// Read the receive buffer
-	return UDR1;
+  // Read the receive buffer
+  return UDR1;
 }
 
 /**
@@ -178,18 +216,16 @@
  * 
  * @see usb_init, usb_getc
  **/
-int usb_getc_nb(char *c)
-{
-	// check if the receive buffer is filled
+int usb_getc_nb(char *c) {
+  // check if the receive buffer is filled
   if (UCSR0A & _BV(RXC0)) {
     // Read the receive buffer
     (*c) = UDR0;
     return 0;
-  }
-  else {
+  } else {
     // Return empty
     return -1;
-	}
+  }
 }
 
 /**
@@ -204,26 +240,24 @@
  *
  * @see xbee_init, xbee_getc
  **/
-int xbee_getc_nb(char *c)
-{
-	// check if the receive buffer is filled
+int xbee_getc_nb(char *c) {
+  // check if the receive buffer is filled
   if (UCSR1A & _BV(RXC1)) {
     // Read the receive buffer
     (*c) = UDR1;
     return 0;
-  }
-  else {
+  } else {
     // Return empty
     return -1;
-	}
+  }
 }
 
 
 /*
-prints an int to serial
+  prints an int to serial
 
-code adapted from Chris Efstathiou's code (hendrix@otenet.gr)
-uses usb_putc
+  code adapted from Chris Efstathiou's code (hendrix@otenet.gr)
+  uses usb_putc
 */
 /**
  * Prints an integer, converted to ASCII, to usb. usb_init must be called
@@ -236,21 +270,74 @@
  * @see usb_init, usb_putc
  **/
 int usb_puti(int value ) {
-	unsigned char usb_data[6]={'0','0','0','0','0','0' }, position=sizeof(usb_data), radix=10; 
+  unsigned char usb_data[6]={'0','0','0','0','0','0' }, position=sizeof(usb_data), radix=10; 
 
-        /* convert int to ascii  */ 
-        if(value<0) { usb_putc('-'); value=-value; }    
-        do { position--; *(usb_data+position)=(value%radix)+'0'; value/=radix;  } while(value); 
+  /* convert int to ascii  */ 
+  if(value<0) { 
+    usb_putc('-'); 
+    value=-value; 
+  }    
+  do { 
+    position--; 
+    *(usb_data+position)=(value%radix)+'0'; 
+    value/=radix;  
+  } while(value); 
 
     
-        /* start displaying the number */
-        for(;position<=(sizeof(usb_data)-1);position++)
-          {
+  /* start displaying the number */
+  for(;position<=(sizeof(usb_data)-1);position++) {
             
-            usb_putc(usb_data[position]);
-          }
+    usb_putc(usb_data[position]);
+  }
 
-	return 0;
+  return 0;
 }
 
+/**
+ * Determines a hexadecimal digit in ASCII code.
+ *
+ * @param value the value of the digit (0<=value<=15)
+ * 
+ * @return the hexadecimal digit in ASCII code, or '?'
+ * if the input is invalid.
+ **/
+uint8_t hex_digit (uint8_t value)
+{
+    if (value>15) return '?';
+    // Postcondition: 0<=x<=15
 
+    return "0123456789ABCDEF"[value];
+}
+
+/**
+ * Prints a fixed width hexadecimal representation of an unsigned
+ * 16 bit integer in ASCII code to USB.
+ * usb_init must be called before this function can be used.
+ *
+ * @param value the value to print
+ * 
+ * @see usb_init, usb_puti, usb_puts, usb_puth8, hex_digit
+ **/
+void usb_puth16 (uint16_t value)
+{
+    usb_putc (hex_digit((value >>12)&0xF));
+    usb_putc (hex_digit((value >>8 )&0xF));
+    usb_putc (hex_digit((value >>4 )&0xF));
+    usb_putc (hex_digit( value      &0xF));
+}
+
+/**
+ * Prints a fixed width hexadecimal representation of an unsigned
+ * 8 bit integer in ASCII code to USB.
+ * usb_init must be called before this function can be used.
+ *
+ * @param value the value to print
+ * 
+ * @see usb_init, usb_puti, usb_puts, usb_puth16, hex_digit
+ **/
+void usb_puth8(uint8_t value)
+{
+    usb_putc (hex_digit ((value)>>4 &0xF));
+    usb_putc (hex_digit ( value     &0xF));
+}
+
Index: branches/encoders/code/projects/libdragonfly/dragonfly_lib.h
===================================================================
--- branches/encoders/code/projects/libdragonfly/dragonfly_lib.h	(revision 1344)
+++ branches/encoders/code/projects/libdragonfly/dragonfly_lib.h	(revision 1345)
@@ -1,74 +1,115 @@
-/**
- * @file dragonfly_lib.h
- * @brief Contains other include files
- * 
- * Include this file for all the functionality of libdragonfly.
- *
- * @author Colony Project, CMU Robotics Club
- **/
-
-#ifndef _DRAGONFLY_LIB_H_
-#define _DRAGONFLY_LIB_H_
-
-/**
- * @addtogroup dragonfly
- * @{
- **/
-
-// Configuration definitions
-/** @brief Initialize analog **/
-#define ANALOG 0x01
-/** @brief Initialize serial communications **/
-#define SERIAL 0x02
-/** @brief Initialize USB communications **/
-#define USB    0x02
-/** @brief Initialize communications **/
-#define COMM   0x02
-/** @brief Initialize the orb **/
-#define ORB    0x04
-/** @brief Initialize the motors **/
-#define MOTORS 0x08
-/** @brief Initialize the servos **/
-#define SERVOS 0x10
-/** @brief Initialize I2C **/
-#define I2C    0x20
-/** @brief Initialize the buzzer **/
-#define BUZZER 0x40
-/** @brief Initialize the LCD screen **/
-#define LCD    0x80
-/** @brief Initialize everything **/
-#define ALL_ON 0xFF
-
-
-/** @brief Initialize the board **/
-void dragonfly_init(int config);
-
-/** @} **/ //end addtogroup
-
-#include <inttypes.h>
-#include <stdio.h>
-#include <stdlib.h>
-#include <avr/io.h>
-#include <avr/interrupt.h>
-#include <util/delay.h>
-#include <util/twi.h>
-
-#include <analog.h>
-#include <dio.h>
-#include <time.h>
-#include <lcd.h>
-#include <lights.h>
-#include <motor.h>
-#include <serial.h>
-#include <buzzer.h>
-#include <rangefinder.h>
-#include <bom.h>
-#include <move.h>
-#include <reset.h>
-#include <math.h>
-
-#include <spi.h>
-#include <encoders.h>
-
-#endif
-
+/**
+ * Copyright (c) 2007 Colony Project
+ * 
+ * Permission is hereby granted, free of charge, to any person
+ * obtaining a copy of this software and associated documentation
+ * files (the "Software"), to deal in the Software without
+ * restriction, including without limitation the rights to use,
+ * copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following
+ * conditions:
+ * 
+ * The above copyright notice and this permission notice shall be
+ * included in all copies or substantial portions of the Software.
+ * 
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
+ * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
+ * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
+ * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
+ * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
+ * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
+ * OTHER DEALINGS IN THE SOFTWARE.
+ **/
+
+
+/**
+ * @file dragonfly_lib.h
+ * @brief Contains other include files
+ * 
+ * Include this file for all the functionality of libdragonfly.
+ *
+ * @author Colony Project, CMU Robotics Club
+ **/
+
+#ifndef _DRAGONFLY_LIB_H_
+#define _DRAGONFLY_LIB_H_
+
+/**
+ * @addtogroup dragonfly
+ * @{
+ **/
+
+// Configuration definitions
+/** @brief Initialize analog **/
+#define ANALOG 0x01
+/** @brief Initialize serial communications **/
+#define SERIAL 0x02
+/** @brief Initialize USB communications **/
+#define USB    0x02
+/** @brief Initialize communications **/
+#define COMM   0x02
+/** @brief Initialize the orb **/
+#define ORB    0x04
+/** @brief Initialize the motors **/
+#define MOTORS 0x08
+/** @brief Initialize I2C **/
+#define I2C    0x20
+/** @brief Initialize the buzzer **/
+#define BUZZER 0x40
+/** @brief Initialize the LCD screen **/
+#define LCD    0x80
+/** @brief Initialize the rangefinders **/
+#define RANGE  0x0100
+/** @brief Initialize the BOM **/
+#define BOM  0x0200
+/** @brief Initialize everything  **/
+#define ALL_ON 0x03FF
+
+/** @brief Initialize the board **/
+void dragonfly_init(int config);
+
+/** @} **/ //end addtogroup
+
+#include <inttypes.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <avr/io.h>
+#include <avr/interrupt.h>
+#include <util/delay.h>
+#include <util/twi.h>
+
+// This file is included from the libdragonfly directory because it seems to be
+// missing from the AVR libc distribution.
+#include "atomic.h"
+
+#include <analog.h>
+#include <dio.h>
+#include <time.h>
+#include <lcd.h>
+#include <lights.h>
+#include <motor.h>
+#include <serial.h>
+#include <buzzer.h>
+#include <rangefinder.h>
+#include <bom.h>
+#include <move.h>
+#include <reset.h>
+#include <math.h>
+#include <eeprom.h>
+#include <stdbool.h>
+
+/** @brief shortcut for ATOMIC_BLOCK(ATOMIC_RESTORESTATE) **/
+#define SYNC ATOMIC_BLOCK(ATOMIC_RESTORESTATE)
+
+/** @brief atomically grab a lock if it is free, return otherwise **/
+#define REQUIRE_LOCK_OR_RETURN(LOCK) do { SYNC { if (LOCK) return; LOCK=1; } } while (0)
+
+/** @brief atomically release a lock **/
+#define RELEASE_LOCK(LOCK) do { LOCK=0; } while (0)
+
+
+
+#endif
+
Index: branches/encoders/code/projects/libdragonfly/buzzer.c
===================================================================
--- branches/encoders/code/projects/libdragonfly/buzzer.c	(revision 1344)
+++ branches/encoders/code/projects/libdragonfly/buzzer.c	(revision 1345)
@@ -1,11 +1,40 @@
-/*
-  buzzer.c - Contains the functions necessary for running the buzzer
-  
-  author: Robotics Club, Colony Project
-  
-  much taken from FWR's firefly library (author: Tom Lauwers)
-*/
+/**
+ * Copyright (c) 2007 Colony Project
+ * 
+ * Permission is hereby granted, free of charge, to any person
+ * obtaining a copy of this software and associated documentation
+ * files (the "Software"), to deal in the Software without
+ * restriction, including without limitation the rights to use,
+ * copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following
+ * conditions:
+ * 
+ * The above copyright notice and this permission notice shall be
+ * included in all copies or substantial portions of the Software.
+ * 
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
+ * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
+ * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
+ * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
+ * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
+ * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
+ * OTHER DEALINGS IN THE SOFTWARE.
+ **/
 
+
+/**
+ * @file buzzer
+ * @brief Functions for using the buzzer
+ *
+ * Contains functions for using the buzzer.
+ *
+ * @author Colony Project, CMU Robotics Club
+ *
+ * much taken from FWR's firefly library (author: Tom Lauwers)
+ **/
+
 #include <avr/io.h>
 #include <buzzer.h>
 #include <time.h>
Index: branches/encoders/code/projects/libdragonfly/i2c.h
===================================================================
--- branches/encoders/code/projects/libdragonfly/i2c.h	(revision 1344)
+++ branches/encoders/code/projects/libdragonfly/i2c.h	(revision 1345)
@@ -1,8 +1,36 @@
+/**
+ * Copyright (c) 2007 Colony Project
+ * 
+ * Permission is hereby granted, free of charge, to any person
+ * obtaining a copy of this software and associated documentation
+ * files (the "Software"), to deal in the Software without
+ * restriction, including without limitation the rights to use,
+ * copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following
+ * conditions:
+ * 
+ * The above copyright notice and this permission notice shall be
+ * included in all copies or substantial portions of the Software.
+ * 
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
+ * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
+ * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
+ * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
+ * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
+ * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
+ * OTHER DEALINGS IN THE SOFTWARE.
+ **/
+
+
 /** @file i2c.h
  *  @brief Header file for I2C
  *
- *  @author CMU Robotics Club, Kevin Woo, Suresh Nidhiry
- */
+ *  Contains functions for I2C.
+ *
+ *  @author Kevin Woo and Suresh Nidhiry, Colony Project, CMU Robotics Club
+ **/
 
 
 #ifndef _I2C_H_
@@ -10,13 +38,13 @@
 
 #include <stddef.h>
 
-/** @brief Address of slave receive handler function */
+/** @brief Address of slave receive handler function **/
 typedef void (*fun_srecv_t)(char);
 
-/** @brief Address of master receive handler function*/
+/** @brief Address of master receive handler function**/
 typedef int (*fun_mrecv_t)(char);
 
-/** @brief Address of slave send handler function*/
+/** @brief Address of slave send handler function**/
 typedef char (*fun_send_t)(void);
 
 int i2c_init(char addr, fun_mrecv_t master_recv, fun_srecv_t slave_recv, fun_send_t slave_send);
@@ -26,3 +54,4 @@
 void i2c_packet_rec (char i2c_byte);
 void i2c_packet_sniff(char data);
 #endif
+
Index: branches/encoders/code/projects/libdragonfly/serial.h
===================================================================
--- branches/encoders/code/projects/libdragonfly/serial.h	(revision 1344)
+++ branches/encoders/code/projects/libdragonfly/serial.h	(revision 1345)
@@ -1,4 +1,30 @@
 /**
+ * Copyright (c) 2007 Colony Project
+ * 
+ * Permission is hereby granted, free of charge, to any person
+ * obtaining a copy of this software and associated documentation
+ * files (the "Software"), to deal in the Software without
+ * restriction, including without limitation the rights to use,
+ * copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following
+ * conditions:
+ * 
+ * The above copyright notice and this permission notice shall be
+ * included in all copies or substantial portions of the Software.
+ * 
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
+ * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
+ * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
+ * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
+ * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
+ * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
+ * OTHER DEALINGS IN THE SOFTWARE.
+ **/
+
+
+/**
  * @file serial.h
  * @brief Contains declarations for serial input and output
  *
@@ -10,7 +36,7 @@
  **/
 
 /*
-	serial.h - Contains definitions and function prototypes for the RS232 serial port
+  serial.h - Contains definitions and function prototypes for the RS232 serial port
   author(s): pkv
   
   Directions:
@@ -19,13 +45,13 @@
   write characters to the serial ports.
   
   UART Mapping:
-    usb_*() -> UART0
-    xbee_*() -> UART1
+  usb_*() -> UART0
+  xbee_*() -> UART1
   
   Options: (Add the following defines to your code to configure this library)
-    #define USB_BAUD { 115200 | 9600 } <= pick ONE value from in here
-    #define XBEE_BAUD { 115200 | 9600 } <= pick ONE value from in here
-    #define USE_STDIO
+  #define USB_BAUD { 115200 | 9600 } <= pick ONE value from in here
+  #define XBEE_BAUD { 115200 | 9600 } <= pick ONE value from in here
+  #define USE_STDIO
   
   Note: If you enable USE_STDIO, the first init function that is called will 
   automatically be linked to stdin, stdout, and stderr.  To use the baud rate 
@@ -42,6 +68,9 @@
 #ifndef _SERIAL_H
 #define _SERIAL_H
 
+#include <inttypes.h>
+#include <avr/pgmspace.h>
+
 /**
  * @defgroup usb USB Input / Output
  * @brief Functions for USB input / output
@@ -67,9 +96,20 @@
 int usb_getc_nb(char *c);
 /** @brief Print a string to USB **/
 int usb_puts(char *s);
+/** @brief Print a string from program space to USB **/
+void usb_puts_P (PGM_P s);
 /** @brief Print an integer to USB **/
 int usb_puti(int value);
+/** @brief Determine a hexadecimal digit **/
+uint8_t hex_digit (uint8_t value);
+/** @brief Print a fixed width hexadecimal representation to USB **/
+void usb_puth16 (uint16_t value);
+/** @brief Print a fixed width hexadecimal representation to USB **/
+void usb_puth8(uint8_t value);
+/** @brief Alias for usb_puth16 **/
+static inline void usb_puth (uint16_t value) { usb_puth16 (value); };
 
+
 /** @} **/ //end addtogroup
 
 /**
@@ -98,6 +138,8 @@
 /** @brief Read a character from the XBee without blocking **/
 int xbee_getc_nb(char *c);
 
+
+
 /** @} **/ //end addtogroup
 
 #endif
Index: branches/encoders/code/projects/libdragonfly/buzzer.h
===================================================================
--- branches/encoders/code/projects/libdragonfly/buzzer.h	(revision 1344)
+++ branches/encoders/code/projects/libdragonfly/buzzer.h	(revision 1345)
@@ -1,4 +1,30 @@
 /**
+ * Copyright (c) 2007 Colony Project
+ * 
+ * Permission is hereby granted, free of charge, to any person
+ * obtaining a copy of this software and associated documentation
+ * files (the "Software"), to deal in the Software without
+ * restriction, including without limitation the rights to use,
+ * copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following
+ * conditions:
+ * 
+ * The above copyright notice and this permission notice shall be
+ * included in all copies or substantial portions of the Software.
+ * 
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
+ * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
+ * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
+ * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
+ * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
+ * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
+ * OTHER DEALINGS IN THE SOFTWARE.
+ **/
+
+
+/**
  * @file buzzer.h
  * @brief Contains definitions for using the buzzer.
  *
Index: branches/encoders/code/projects/libdragonfly/eeprom.c
===================================================================
--- branches/encoders/code/projects/libdragonfly/eeprom.c	(nonexistent)
+++ branches/encoders/code/projects/libdragonfly/eeprom.c	(revision 1345)
@@ -0,0 +1,55 @@
+#include <avr/io.h>
+#include "eeprom.h"
+
+int eeprom_put_byte(unsigned int uiAddress, unsigned char ucData) {
+    /* Wait for completion of previous write */
+    while(EECR & (1<<EEWE));
+    /* Set up address and data registers */
+    EEAR = uiAddress;
+    EEDR = ucData;
+    /* Write logical one to EEMWE */
+    EECR |= (1<<EEMWE);
+    /* Start eeprom write by setting EEWE */
+    EECR |= (1<<EEWE);
+    
+    return 0;
+}
+
+int eeprom_get_byte(unsigned int uiAddress, unsigned char *byte) {
+    /* Wait for completion of previous write */
+    while(EECR & (1<<EEWE));
+    /* Set up address register */
+    EEAR = uiAddress;
+    /* Start eeprom read by writing EERE */
+    EECR |= (1<<EERE);
+    /* get data from data register */
+    *byte=EEDR;
+    
+    return 0;
+}
+
+
+unsigned char get_robotid(void) {
+    unsigned char c0, c1, c2;
+    
+    eeprom_get_byte(EEPROM_ROBOT_ID_ADDR, &c0);
+    eeprom_get_byte(EEPROM_ROBOT_ID_ADDR+1, &c1);
+    eeprom_get_byte(EEPROM_ROBOT_ID_ADDR+2, &c2);
+    if(c0 == 'I' && c1 == 'D')
+        return c2;
+    else
+        return 0xFF;
+}
+
+unsigned char get_bom_type(void) {
+    unsigned char c0, c1, c2, c3;
+    
+    eeprom_get_byte(EEPROM_BOM_TYPE_ADDR, &c0);
+    eeprom_get_byte(EEPROM_BOM_TYPE_ADDR+1, &c1);
+    eeprom_get_byte(EEPROM_BOM_TYPE_ADDR+2, &c2);
+    eeprom_get_byte(EEPROM_BOM_TYPE_ADDR+3, &c3);
+    if(c0 == 'B' && c1 == 'O' && c2 == 'M')
+        return c3;
+    else
+        return 0xFF;
+}
Index: branches/encoders/code/projects/libdragonfly/spi.c
===================================================================
--- branches/encoders/code/projects/libdragonfly/spi.c	(revision 1344)
+++ branches/encoders/code/projects/libdragonfly/spi.c	(revision 1345)
@@ -2,7 +2,6 @@
  * @file spi.c
  * @brief Basic SPI module to handle encoders
  * @author Colony Project, CMU Robotics Club
- * @bug Not tested
  *	Need to move spi.h include into dragonfly_lib.h when stable
  **/
 
@@ -15,6 +14,12 @@
 static spi_fun_recv_t spi_recv_func; /* byte handler */
 static spi_fun_recv_complete_t spi_recv_complete_func; /*transmission completion handler */
 
+/** 
+* @brief Initialize SPI hardware for communication.
+* 
+* @param recv_func The function to be called for each byte of data received.
+* @param recv_complete_func  The function to be called at the end of a complete transmission.
+*/
 void spi_init (spi_fun_recv_t recv_func, spi_fun_recv_complete_t recv_complete_func)
 {
     /*  Enable Interrupt, Enable SPI Module, MSB First, Master Mode, Clock div = 64 */
@@ -35,7 +40,11 @@
     //usb_puts("\tspi.c Debug: SPI INITIALIZED\n");
 }
 
-/* Transfer a given byte to slave and receive a byte */
+/** 
+* @brief Transfer a given byte to slave and receive a byte 
+* 
+* @param bytes The number of bytes to be transferred.
+**/
 void spi_transfer(char bytes)
 {
     spi_bytes = bytes;
Index: branches/encoders/code/projects/libdragonfly/eeprom.h
===================================================================
--- branches/encoders/code/projects/libdragonfly/eeprom.h	(nonexistent)
+++ branches/encoders/code/projects/libdragonfly/eeprom.h	(revision 1345)
@@ -0,0 +1,49 @@
+/**
+ * @file eeprom.h
+ * @brief handles eeprom storage for persistent data
+ *
+ * Contains functions and definitions for reading and writing to eeprom
+ *
+ * @author Colony Project, Brad Neuman
+ */
+ 
+ #ifndef _EEPROM_H_
+ #define _EEPROM_H_
+ 
+ #include <bom.h>
+ 
+ #define EEPROM_ROBOT_ID_ADDR 0x10
+ #define EEPROM_BOM_TYPE_ADDR 0x14
+ 
+ /** @brief store a byte to eeproem
+  *  @return 0 if success, nonzero on failure
+  */
+ int eeprom_put_byte(unsigned int addr, unsigned char byte);
+ 
+ /** @brief reads a byte from eeprom
+  *
+  *  Pass it thge address and a pointer to a byte where the byte at the
+  *  address will be stored
+  *
+  *  @return 0 if successful (byte is set to the eeprom value at addr), 
+  *  nonzero if there was a problem
+   */
+ int eeprom_get_byte(unsigned int addr, unsigned char *byte);
+ 
+ /** @brief get stored robot ID
+  *
+  *  checks that EEPROM has been programed with an ID and returns it
+  *
+  *  @return the robot id, if it is stored. If it returns 0xFF it is probably invalid
+  */
+ unsigned char get_robotid(void);
+  
+   /** @brief get stored robot ID
+  *
+  * checks that EEPROM has been programed with an BOM type and returns it
+  *
+  *  @return the robot bom type as defined in bom.h, if it is stored. If it returns 0xFF it is probably invalid
+  */
+ unsigned char get_bom_type(void);
+ 
+ #endif
Index: branches/encoders/code/projects/libdragonfly/Makefile
===================================================================
--- branches/encoders/code/projects/libdragonfly/Makefile	(revision 1344)
+++ branches/encoders/code/projects/libdragonfly/Makefile	(revision 1345)
@@ -69,7 +69,6 @@
 CDEFS += -DF_CPU=$(F_CPU)UL 
 
 # Place -I options here
-CINCS =
 
 
 #---------------- Compiler Options ----------------
@@ -162,9 +161,9 @@
 
 publish:
 	$(COPY) $(TARGET).a $(COLONYROOT)/code/lib/bin
-	$(COPY) *.c $(COLONYROOT)/code/lib/src/$(TARGET)
 	$(COPY) *.h $(COLONYROOT)/code/lib/include/$(TARGET)
 
+.PHONY: docs
 docs:
 	$(DOXYGEN)
 	$(COPY) docs/html/* $(COLONYROOT)/docs/$(TARGET)
